// Ansteuerung eines HD44780 kompatiblen LCD im 4-Bit-Interfacemodus
// http://www.mikrocontroller.net/articles/AVR-GCC-Tutorial
//
extern void lcd_data(unsigned char temp1);
extern void lcd_string(char *data);
extern void lcd_command(unsigned char temp1);
extern void lcd_enable(void);
extern void lcd_init(void);
extern void lcd_home(void);
extern void lcd_clear(void);
extern void set_cursor(uint8_t x, uint8_t y);
 
// Hier die verwendete Taktfrequenz in Hz eintragen, wichtig!
 
//#define F_CPU 8000000
 
// LCD Befehle
 
#define CLEAR_DISPLAY 0x01
#define CURSOR_HOME   0x02
 
// Pinbelegung für das LCD, an verwendete Pins anpassen
 
#define LCD_PORT      PORTA
#define LCD_DDR       DDRA
#define LCD_RS        PA4
#define LCD_EN        PA5
// DB4 bis DB7 des LCD sind mit PD0 bis PD3 des AVR verbunden  

#include "lcd-0.1.c"
