#include <stdlib.h>
#include <string.h>	
#include <avr/io.h>
#include <avr/pgmspace.h>	
#include <avr/interrupt.h>			

#define F_CPU 16000000
#include <util/delay.h>

char command[5];						// commando (größtes : "cd..")
char data[13];							// maximal 8.3 bei datei namen !

#define BUFF_SIZE 15					// puffer größe, der eingaben der tastatur und temp-string größe!
unsigned char kb_buffer[BUFF_SIZE];		// enthält decodierte scancodes und ist tmp string für z.b. ultoa()...

#define keyboard 0						// 0 über uart. 1 dann is am mc eine tastatur angeschlossen (siehe kb-0.x.h)

#define benchmark 1						// wenn benchmark 0 wird der benchmark teil nicht mit kompiliert !

//*****************************************************************************************************************
#include "uart-0.1.h"			
#include "mmc-0.2.h"			
#include "fat-0.3.h"			
#include "file-0.3.h"			
//#include "lcd-0.1.h"
//#include "kb-0.1.h"			
//*****************************************************************************************************************

unsigned char 	run_cmd(void);										// zeigt commando prompt.
unsigned char 	fat_str(char str[]);								// bereitet string auf, z.b. "t.txt" -> "T        TXT", mit prüfung.
unsigned char 	cmd_data(char *string);								// teilt cmd_str (aus run_cmd) auf in command und parameter (data).
unsigned char*	strings (PGM_P str) __ATTR_CONST__;					// legt strings im flash ab.
void			benchm(unsigned char, unsigned long int);			// benchmark funktion.

#if benchmark	// timer isr
// ***********************************************************
// tick 1000/sec -> ms
// benchmark timer0 atmega168 @ 16mhz CTC 
// ***********************************************************
unsigned int 	i=0;	//ms
unsigned char 	j=0;	//sekunden
unsigned char 	n=0;	//minuten
ISR(TIMER0_COMPA_vect){

	if(i++==10000){
		j++;
		i=0;
		}

	if(j==60){
		j=0;
		n=1;	
		}

}
#endif


//*****************************************************************************************************************
// init: uart, lcd, keyboard (kb), mmc, fat. ruft run_cmd auf -> kommando prompt
// hat benchmark teil.
//*****************************************************************************************************************
void main(void){

  uinit(); 
  //lcd_init();
  //init_kb();      
  uputs((char *)strings(PSTR("\n\rBoot")));


  while (mmc_init() !=0){ 			//ist der Rückgabewert ungleich NULL ist ein Fehler aufgetreten	
	;	
	} 

  uputs((char *)strings(PSTR("... ")));

  if(0==fat_initfat()){

 	uputs((char *)strings(PSTR("Ok\n\r")));	  // wenn auf dem terminal "Boot... OK" zu lesen ist, init ok.

	run_cmd();				// zeigt command prompt	 	

#if benchmark			// datei schreiben, anschließendes lesen
	// benchmark teil... 
	fat_str("d.txt");

	ffrm(kb_buffer);			// kb_buffer nur tmp buffer für die wandlung die fat_str macht !
	benchm(1,10000);			// schreiben

	i=0;	//ms
	j=0;	//sekunden
	n=0;	//minuten
	fat_str("d.txt");
	benchm(0,0);			// lesen 
#endif
 	}
}


// ***********************************************************
unsigned char* strings (PGM_P str){
  return (unsigned char *)strcpy_P((char *)kb_buffer,str);	
}


// *****************************************************************************************************************
// zeigt commando prompt an, ist endloschleife.
// es können alle fat funktionen hier getestet werden (bis auf ffseek). liest wahlweise uber uart oder angeschlossene
// tastatur ein (siehe kb-0.x.h für die pins die angeschlossen werden müssen).
/**
run_cmd handhabung: 

-wenn datei mit "or" zum lesen geöffnet, kann mit ls der inhalt ausgegeben werden. die datei muss mit "c"
geschlossen werden um andere operationen auszuführen. 

-wenn datei mit "ow" zum schreiben geöffnet ist kann mit "w" in die datei geschrieben werden, abbruch zeichen ist "ESC"-taste. 
die datei muss mit "c" geschlossen werden um andere operationen auszuführen. 
die datei muss erst geschlossen werden um sie zu lesen.

-wenn datei mit "oa" zum anhängen geöffnet ist, kann mit "w" an die datei angehangen werden, abbruch zeichen ist "ESC"-taste.
die datei muss mit "c" geschlossen werden um andere operationen auszuführen. 
die datei muss erst geschlossen werden um sie zu lesen.

-"rm datei" löscht datei mit dem namen "datei" aus aktuellem verzeichniss, wenn es die datei gibt.
löschen von ordner noch nicht vorgesehen, da man diese rekursiv löschen müsste.

-"cd dirname" wechselt in verzeichniss "dirname". immer nur ein verzeichniss. "cd dir1/dir2" geht nicht !

-"cd.." wechselt in parent verzeichniss.

-"ls" ohne vorherige datei operation zeigt ordner inhalt an. "ls" wenn "or" dann wird datei inhalt angezeigt.

-mit "q" wird run_cmd beendet !
*/
// *****************************************************************************************************************
unsigned char run_cmd(void){						
  
  char cmd_str[15];						// enthält eingelesenen kommando string.
  char directory[30];					// enthält dir namen oder datei namen wenn zum lesen/anhängen/schreiben geöffnet.
  char flag=0;							// flag für or,ow usw...
  unsigned char c;						// zum zeichenweise einlesen.
  unsigned char i;						// zähler für die eingelesenen zeichen.
 
  strcpy(directory,"dan:");	

  do{
	uputs("\n\r");						// neue zeile.
	uputs(directory); 					// zeigt dir an.
	uputs(" >:");						// command prompt.	

	i=0;
	c=0;

	while(c!=13 && i<15){				// liest zeichen ein, maximal 15 oder bis RETURN gedrückt.			 
	  if(keyboard==0)c=ugetc();			// wartet auf zeichen eingabe über uart.
	  //else c=getchar();				// liest zeichen von angeschlossener tastatur.
	  if(c==0x1B)return(0);				// abbruch, ESC gedrückt.
	  uputc(c);							// gibt zeichen aus (uart).
	  cmd_str[i]=c;						// speichern von zeichen auf cmd_string.
	  i++;								// zähler anzahl eingelesene zeichen.
	  }
	cmd_str[i-1]='\0';					// terminiert cmd_str, weil abbruch zeichen noch gespeichert wird.
	
	cmd_data(cmd_str);					// teilt string in befehl und parameter(daten) auf.

		// cd ************************************************************************************************* 
		if(0==strcmp(command,"cd")&&flag==0){			// befehl cd erkannt	
		  if(0==fat_str(data)){								// bereitet string auf, mit prüfungen.		
			if(0==ffcd(kb_buffer)){							// wechselt in directory.
 			  strcat(directory,"/"); 						// kopiert "/" auf directory string.									
 			  strcat(directory,data);						// kopiert dir namen auf directory string.
			  }	
			}
		  }

		// cd.. *************************************************************************************************
		if(0==strcmp(command,"cd..")&&flag==0){			// befehl cd.. erkannt	
		  if(0==ffcdLower()) {								// geht in partent dir
 			char *ptr;										// zeigt auf letzte stelle an der / vorkommt	
 			ptr=strrchr(directory,'/');						// letztes vorkommen von /
 			*ptr = '\0' ;									// stelle von letztem / wird mit \0 überschrieben	
			}	
		  }	

		// rm *************************************************************************************************
		if(0==strcmp(command,"rm")&&flag==0){			// befehl remove	
		  if(0==fat_str(data)){								// bereitet string auf, mit prüfungen.					
			if(0==ffrm(kb_buffer)){							// löscht datei.
			  }	
			}
		  }

		// or *************************************************************************************************
		if(0==strcmp(command,"or")&&flag==0){			// befehl open to read erkannt	
		  if(0==fat_str(data)){								// bereitet string auf, mit prüfungen.					
			if(0==ffopen('r',kb_buffer)){					// öffnet datei zum lesen
 			  strcat(directory,"/");						// kopiert "/" auf directory string.									
 			  strcat(directory,data);						// kopiert datei namen auf directory string.
 			  flag=1;										// flag==1 -> datei lesen
			  }	
			}
		  }

		// ow *************************************************************************************************
		if(0==strcmp(command,"ow")&&flag==0){			// befehl open to write erkannt	
		  if(0==fat_str(data)){								// bereitet string auf, mit prüfungen.					
			if(0==ffopen('w',kb_buffer)){					// öffnet datei zum schreiben
 			  strcat(directory,"/");						// kopiert "/" auf directory string.									
 			  strcat(directory,data);						// kopiert datei namen auf directory string.
			  flag=2;										// flag==2 -> datei schreiben					
			  }	
			}
		  }

		 // oa *************************************************************************************************
		if(0==strcmp(command,"oa")&&flag==0){			// befehl open to append erkannt.	
		  if(0==fat_str(data)){								// bereitet string auf, mit prüfungen.					
			if(0==ffopen('a',kb_buffer)){					// öffnet datei zum anhängen.
			  strcat(directory,"/");						// kopiert "/" auf directory string.									
			  strcat(directory,data);						// kopiert datei namen auf directory string.
			  flag=3;										// flag==3 -> datei anhängen.					
			  }	
			}
		  }

		// w *************************************************************************************************
		if(0==strcmp(command,"w")&&flag>1){			 	// befehl write erkannt.
			unsigned char c;								//schreibt bei open to write und open to append
			uputs("\n\r>\n\r");			
			do{				
				c=ugetc();									// liest byte ein (von uart).
				if(c==27)break;								// abbruch nur wenn ESC gedrückt.
				ffwrite(c);									// schreibt byte auf karte.
				uputc(c);									// echo von byte auf uart.
				}while(1);			
			uputs("\n\r<");			
			}

		// c *************************************************************************************************
		if(0==strcmp(command,"c")&&flag!=0){			// befehl close erkannt				
			if(0==ffclose() ){
 				char *ptr;									// siehe oben !
 				ptr=strrchr(directory,(int)'/');
 				*ptr = '\0' ;					
				flag=0;				
				}	
			}

		// ls *************************************************************************************************
		if(0==strcmp(command,"ls")&&flag<2){			// befehl ls , 2 optionen: 1==datei inhalt, 0==directory anzeigen.
		  uputs("\n\r");
		  if(flag==1){										// datei zum lesen geöffnet !
			if(file.length>0){								// prüfen ob daten in datei ! sonnst ist while(--seek) immer falsch.
			  do{											// wiederholt so lange wie bytes da sind.						
				uputc(ffread());							// zeigt gelesenes byte auf uart				  				
				}while(--seek);								// solange bytes da sind			  
				ffclose();									// TODO einfacheren weg finden um alles aufzuräumen,	
				strcpy((char*)kb_buffer,(char*)file.name);
				ffopen('r',kb_buffer);						// schließt datei und öffnet dann wieder zum lesen!!			  
				uputs("\n\r");
			  }
			}
		  if(flag==0){										// directory anzeigen
			if(0==ffls());									// zeigt kompletten directory inhalt an !					
			}
		  }


		// q *************************************************************************************************
		if(0==strcmp(command,"q")){							// befehl quit erkannt				
			ffclose();										// falls datei geöffnet war...
 			break;	
			}

  }while(1);
  return (0);
}




// *****************************************************************************************************************
// bereitet str so auf, dass man es auf die mmc/sd karte schreiben kann, wird prüfungen unterzogen.
// wandelt z.b. "t.txt" -> "T        TXT"
// *****************************************************************************************************************
unsigned char fat_str(char str[]){

  // 1. prüft ob gesammter string zu groß.
  // 2. prüft auf stellen nach dem punkt (max 3).
  // 3. prüft auf stellen vor dem punkt (max 8).
  // 4. pruft auf mehrere punkte. es ist max 1 punkt erlaubt.

  if(strlen(str)>12)	return(1);	// string zu groß, abbruch !!
  
  unsigned char i=0;				// zähler für string.
  unsigned char j=0;  				// zähler für str.
  unsigned char c;					// zeichen aus str, wird so gemacht, um die zeichen prüfen zu können.
  unsigned char dot=0;				// stelle des punktes.
  unsigned char string[13];   

  strupr(str);				// a-z -> A-Z
    
  do{
	c = str[j];		
	
	if(c=='.'){						// punkt weglassen !!	
	  if(dot!=0) return (4);		// mehr als 1 punkt, abbruch !!
	  dot=i;						// punkt vorhanden, an stelle i.
 	  j++;							// nächstes zeichen in strn (nach '.').
	  continue;						// springt hoch, um den '.' nicht auf string zu schreiben !
	  }	

	if(dot!=0 && i<8){				// muss mit leerzeichen aufgefüllt werden (immer 8.3).
	  c=' ';						// leerzeichen (0x20).
	  j--;							// j wird zurück gesetzt, um aus dem orginal string noch nicht den nächsten c zu holen,
	  }								// da erst mit leerzeichen aufgefüllt werden muss !	
					
	if(dot!=0 && (dot+4)==j) return(2);	// zu viele stellen nach dem punkt, abbruch !!
	if(i>7 && dot==0)		 return(3);	// zu viele stellen im namen, abbruch !!  	

	string[i] = c;					// zeichen aus str auf string schreiben.
	i++;							// zähler für string.
	j++;							// zähler für str.
  }while(str[j]!='\0');

  for(;i<11;i++)string[i]=' ';		// mit leerzeichen auffüllen, ab dem letzten zeichen, bei ordnern, 3 zeichen sonst bis zu 2.
  string[i]='\0';					// abschluss des strings.
  
  strcpy((char*)kb_buffer,(char*)string);				// arbeitsstring auf globalen kopieren.	

  return(0);

}



// *****************************************************************************************************************
// teilt string auf in commando und parameter(daten).
// z.b. "cd dir1" -> command=="cd" data=="dir1"
// *****************************************************************************************************************
unsigned char cmd_data(char *string){
	
  if(15<strlen(string)) return (1);			// fehler, string zu groß.

  unsigned char i=0;    
  char *str=&string[0];						// pointer auf string.
  char *space= strchr(string,(int)' ');		// trennzeichen, wenn vorhanden.
	
  do{
  
	if(space==NULL){						// kein trennzeichen, also nur kommando.
	  command[i]=*str;
	  }
	 
	else{									// trennzeichen da, also kommando und data.
	  if(str<space)  command[i]=*str;		// kommando vor trennzeichen . 
	  if(str==space) {
		command[i]='\0';					// abschluss commando string (data weiter unten !!).
		i=-1;								// trennzeichen (-1 weil in schleife eins hochgezählt wird).			 
		}
	  if(str>space)  data[i]=*str;			// daten nach trennzeichen. 
	  }
  
  str++;
  i++;
  }while(*str!='\0');
  
  if(space!=0)data[i]='\0';					// string abschluss wenn cmd und data (command weiter oben!).
  else {									// string abschluss wenn nur cmd (data[0]='\0' !!).
	command[i]='\0';
	data[0]='\0';
	}
  return(0);
}




#if benchmark			// benchmark funktion
// *************************************************************************************************
// benchmark funktion (timer0 muss an sein dafür und "benchmark 1").
// flag entscheidet ob lesen oder schreiben. wenn schreiben werden count anzahl zeichen geschrieben.
// *************************************************************************************************
void benchm(unsigned char flag, unsigned long int count){
  
  if(flag==0){  		// read
/*
	OCR0 =125;								//125
	TIMSK |= (1<<OCIE0);						// compare interrupt an
	TCCR0 |= (1<<WGM01)|(1<<CS01)|(1<<CS00);	// ctc mode, prescaler 64
*/
	OCR0A =200;									// atmega168 -> 10.000 tick / sec @ 16 mhz
	TCCR0A |= (1<<WGM01);	
	TCCR0B |= (1<<CS01);	
	TIMSK0 |= (1<<OCIE0A);	// compare interrupt an
	
	sei();	
 
	ffopen('r',kb_buffer);	
	do{
	  ffread();
	  }while(--seek);  
	ffclose();
	
	cli();

	TCCR0A =0;
	TCCR0B =0;	
	OCR0A =0;
/*
	TCCR0 =0;	
	TIMSK =0;
	OCR0=0;
*/	
  }

  if(flag==1){			// write
 /*
	OCR0 =125;								//125
	TIMSK |= (1<<OCIE0);						// compare interrupt an
	TCCR0 |= (1<<WGM01)|(1<<CS01)|(1<<CS00);	// ctc mode, prescaler 64
*/

	OCR0A =200;
	TCCR0A |= (1<<WGM01);	
	TCCR0B |= (1<<CS01);	
	TIMSK0 |= (1<<OCIE0A);	// c
	
	sei();	
 
	ffopen('w',kb_buffer);	
	unsigned long int z;
	for(z=0;z<count;z++){
	  ffwrite('w');		  
	  //file.length++;												// geschriebene bytes erhöhen		
	  }
	ffclose();

	cli();

	TCCR0A =0;
	TCCR0B =0;	
	OCR0A =0;

/*	
	TCCR0 =0;	// timer aus ! 
	TIMSK =0;
	OCR0=0;
*/
	

	}


  // uart anzeige
  //   uputs("\n\rm:");
  //   uputs(utoa(n,(char*)kb_buffer,10));
  uputs("\n\rs:");	
  uputs(utoa(j,(char*)kb_buffer,10));
  uputs(" ms:");	
  uputs(utoa(i/10,(char*)kb_buffer,10));
  uputs("\n\r");		

}
#endif


